import { __assign } from "tslib";
var headerAccept = 'accept';
var headerContentType = 'content-type';
var mimeApplicationJson = 'application/json';
export function httpFetch(config, path, options) {
    if (options === void 0) { options = {}; }
    var baseInit = config.default || {};
    var baseHeaders = baseInit.headers || {};
    var baseUrl = config.base || location.origin;
    var _a = options.method, method = _a === void 0 ? 'get' : _a, body = options.body, _b = options.headers, headers = _b === void 0 ? {} : _b, _c = options.cache, cache = _c === void 0 ? baseInit.cache : _c, _d = options.mode, mode = _d === void 0 ? baseInit.mode : _d, _e = options.result, result = _e === void 0 ? 'auto' : _e;
    var json = Array.isArray(body) ||
        typeof body === 'number' ||
        (typeof body === 'object' && body instanceof FormData === false && body instanceof Blob === false);
    var url = new URL(path, baseUrl);
    var init = __assign(__assign({}, baseInit), { method: method, body: json ? JSON.stringify(body) : body, headers: __assign(__assign({}, baseHeaders), headers), cache: cache,
        mode: mode });
    if (json) {
        init.headers[headerContentType] = 'application/json';
        init.headers[headerAccept] = mimeApplicationJson;
    }
    return fetch(url.href, init).then(function (res) {
        var contentType = res.headers.get(headerContentType);
        var json = result === 'json' || (result === 'auto' && !!contentType && contentType.indexOf('json') !== -1);
        var promise = json ? res.json() : res.text();
        return promise.then(function (body) { return ({
            body: body,
            code: res.status,
            text: res.statusText,
        }); });
    });
}
//# sourceMappingURL=fetch.js.map